<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="三类类型" prop="ttsaType">
        <el-select v-model="queryParams.ttsaType" placeholder="请选择三类类型" clearable>
          <el-option v-for="dict in ttsa_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="考核结果" prop="assResu">
        <el-select v-model="queryParams.assResu" placeholder="请选择考核结果" clearable>
          <el-option v-for="dict in ttsa_ass_resu" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['ttsa:ttsarec:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['ttsa:ttsarec:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['ttsa:ttsarec:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['ttsa:ttsarec:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="ttsa-ttsarec-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="三类GUID" prop="ttsaGuid" />
      <el-table-column label="人员三类GUID" prop="persTtsGuid" />
      <el-table-column label="三类类型" prop="ttsaType" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_type" :value="scope.row.ttsaType" />
        </template>
      </el-table-column>
      <el-table-column label="三类分数" prop="ttsaScore" />
      <el-table-column label="考核结果" prop="assResu" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_ass_resu" :value="scope.row.assResu" />
        </template>
      </el-table-column>
      <el-table-column label="记录日期" prop="recDate" width="180" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ttsa:ttsarec:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ttsa:ttsarec:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="650px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="三类GUID" prop="ttsaGuid">
          <el-input v-model="form.ttsaGuid" placeholder="请输入三类GUID" />
        </el-form-item>
        <el-form-item label="人员三类GUID" prop="persTtsGuid">
          <el-input v-model="form.persTtsGuid" placeholder="请输入人员三类GUID" />
        </el-form-item>
        <el-form-item label="考试GUID" prop="examGuid">
          <el-input v-model="form.examGuid" placeholder="请输入考试GUID" />
        </el-form-item>
        <el-form-item label="三类类型" prop="ttsaType">
          <el-select v-model="form.ttsaType" placeholder="请选择三类类型">
            <el-option v-for="dict in ttsa_type" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="三类分数" prop="ttsaScore">
          <el-input v-model="form.ttsaScore" placeholder="请输入三类分数" />
        </el-form-item>
        <el-form-item label="考核结果" prop="assResu">
          <el-select v-model="form.assResu" placeholder="请选择考核结果">
            <el-option v-for="dict in ttsa_ass_resu" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="记录日期" prop="recDate">
          <el-date-picker v-model="form.recDate" type="datetime" placeholder="选择记录日期" clearable />
        </el-form-item>
        <el-form-item label="组织GUID" prop="orgGuid">
          <el-input v-model="form.orgGuid" placeholder="请输入组织GUID" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TtsaRec">
import { listBisTtsaRec, getBisTtsaRec, addBisTtsaRec, updateBisTtsaRec, delBisTtsaRec } from "@/api/slaj/ttsa";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { ttsa_type, ttsa_ass_resu } = proxy.useDict("ttsa_type", "ttsa_ass_resu");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ ttsaGuid: { visible: true }, persTtsGuid: { visible: true }, ttsaType: { visible: true }, ttsaScore: { visible: true }, assResu: { visible: true }, recDate: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, ttsaType: null, assResu: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisTtsaRec(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加考核记录";
}

function handleUpdate(row) {
  reset();
  getBisTtsaRec(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改考核记录";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisTtsaRec(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisTtsaRec(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisTtsaRec(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/ttsa/ttsarec/export', { ...queryParams.value }, `考核记录_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, ttsaGuid: null, persTtsGuid: null, examGuid: null, ttsaType: null, ttsaScore: null, assResu: null, recDate: null, orgGuid: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
